const count = async ({
  inlineLedgerRunQuery,
  escapeId,
  escapeStr,
  tablePrefix,
  searchToWhereExpression,
  makeNestedPath,
  schemaName
}, readModelName, tableName, searchExpression) => {
  const searchExpr = searchToWhereExpression(searchExpression, escapeId, escapeStr, makeNestedPath);
  const inlineSearchExpr = searchExpr.trim() !== '' ? `WHERE ${searchExpr} ` : '';
  const rows = await inlineLedgerRunQuery(`SELECT Count(*) AS ${escapeId('Count')}
    FROM ${escapeId(schemaName)}.${escapeId(`${tablePrefix}${tableName}`)}
    ${inlineSearchExpr};`);

  if (Array.isArray(rows) && rows.length > 0 && rows[0] != null && Number.isInteger(+rows[0].Count)) {
    return +rows[0].Count;
  }

  return 0;
};

export default count;
//# sourceMappingURL=count.js.map