"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
const MAX_LIMIT_VALUE = 0x0fffffff | 0;

const find = async ({
  inlineLedgerRunQuery,
  escapeId,
  escapeStr,
  tablePrefix,
  searchToWhereExpression,
  makeNestedPath,
  convertResultRow,
  schemaName
}, readModelName, tableName, searchExpression, fieldList, sort, skip, limit) => {
  const orderExpression = sort && Object.keys(sort).length > 0 ? 'ORDER BY ' + Object.keys(sort).map(fieldName => {
    const [baseName, ...nestedPath] = fieldName.split('.');
    const provisionedName = nestedPath.length === 0 ? escapeId(baseName) : `${escapeId(baseName)}->'${makeNestedPath(nestedPath)}'`;
    return sort[fieldName] > 0 ? `${provisionedName} ASC` : `${provisionedName} DESC`;
  }).join(', ') : '';
  const skipLimit = `
    OFFSET ${isFinite(+skip) ? +skip : 0}
    LIMIT ${isFinite(+limit) ? +limit : MAX_LIMIT_VALUE}
  `;
  const searchExpr = searchToWhereExpression(searchExpression, escapeId, escapeStr, makeNestedPath);
  const inlineSearchExpr = searchExpr.trim() !== '' ? `WHERE ${searchExpr} ` : '';
  const inputRows = await inlineLedgerRunQuery(`SELECT * FROM ${escapeId(schemaName)}.${escapeId(`${tablePrefix}${tableName}`)}
    ${inlineSearchExpr}
    ${orderExpression}
    ${skipLimit};`);
  const rows = [];

  for (let idx = 0; idx < inputRows.length; idx++) {
    rows[idx] = convertResultRow(inputRows[idx], fieldList);
  }

  return rows;
};

var _default = find;
exports.default = _default;
//# sourceMappingURL=find.js.map