"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

const getProperty = async (pool, readModelName, key) => {
  const {
    inlineLedgerRunQuery,
    schemaName,
    tablePrefix,
    escapeId,
    escapeStr
  } = pool;
  const databaseNameAsId = escapeId(schemaName);
  const ledgerTableNameAsId = escapeId(`${tablePrefix}__${schemaName}__LEDGER__`);

  try {
    pool.activePassthrough = true;
    const rows = await inlineLedgerRunQuery(`SELECT "Properties" -> ${escapeStr(key)} AS "Value"
     FROM  ${databaseNameAsId}.${ledgerTableNameAsId}
     WHERE "EventSubscriber" = ${escapeStr(readModelName)}
    `);

    if (rows.length === 1 && rows[0].Value != null) {
      return rows[0].Value;
    } else {
      return null;
    }
  } finally {
    pool.activePassthrough = false;
  }
};

var _default = getProperty;
exports.default = _default;
//# sourceMappingURL=get-property.js.map